//
//  IPTCPeeper.h
//  newIPTCViewer
//
//  Created by Joakim Braun admin on 2007-01-06.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>
#import "CombinedArrayController.h"

@interface IPTCPeeper : NSObject {

	EventHandlerRef	mMouseDownEventHandler,
					mMouseUpEventHandler;
	NSWindow*		mIPTCPeeper;
	NSObjectController* mIPTCPeeperDataController;
	NSTextField*		mTextField;
	bool mDidHideOnApplicationSwitch;
	
	NSArrayController	*mBylineSpecController,
						*mCaptionSpecController;
	CombinedArrayController 	*mCombinedController;
}

+ (IPTCPeeper*) sharedInstance;

- (id) init;
- (void) dealloc;

- (void) awakeFromNib;
- (IBAction) showIPTCPeeperAction:(id) inSender;
- (IBAction) toggleIPTCPeeperAction:(id) inSender;
- (void) showPeeper:(HIPoint) mousePoint;
- (void) hidePeeper;
- (void) textChanged;
- (void) adjustPeeperSizeToText;
- (void) setPeeperColorsFromUserDefaults;

- (void) installClickEventHandlers;
- (void) removeClickEventHandlers;
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context;

- (OSStatus) handleIPTCPeeperMouseDown:(EventRef) mouseDownEvent nextHandler: (EventHandlerCallRef) inNextHandler;
- (OSStatus) handleIPTCPeeperMouseUp:(EventRef) mouseDownEvent nextHandler: (EventHandlerCallRef) inNextHandler;

- (void) frontApplicationSwitch: (NSString*) inApplicationSignature;
- (void)windowDidResignKey:(NSNotification *)aNotification;

@end

@interface IPTCPeeperTextController : NSObjectController
{

}

- (void) awakeFromNib;
- (id) selection;
- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change context:(void *)context;
@end